> ## Documentation Index
> Fetch the complete documentation index at: https://memos-api.openmem.net/llms.txt
> Use this file to discover all available pages before exploring further.

# Feedback memories

> Feedback memories for a specific user.

This endpoint uses the class-based FeedbackHandler for better code organization.



## OpenAPI

````yaml mintdocs/openapi.json post /product/feedback
openapi: 3.1.0
info:
  title: MemOS API
  version: 1.0.0
servers: []
security: []
paths:
  /product/feedback:
    post:
      tags:
        - Server API
      summary: Feedback memories
      description: >-
        Feedback memories for a specific user.


        This endpoint uses the class-based FeedbackHandler for better code
        organization.
      operationId: feedback_memories_product_feedback_post
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/APIFeedbackRequest'
        required: true
      responses:
        '200':
          description: Successful Response
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/MemoryResponse'
        '422':
          description: Validation Error
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/HTTPValidationError'
components:
  schemas:
    APIFeedbackRequest:
      properties:
        user_id:
          type: string
          title: User Id
          description: User ID
        session_id:
          anyOf:
            - type: string
            - type: 'null'
          title: Session Id
          description: Session ID for soft-filtering memories
          default: default_session
        task_id:
          anyOf:
            - type: string
            - type: 'null'
          title: Task Id
          description: Task ID for monitering async tasks
        history:
          anyOf:
            - items:
                anyOf:
                  - $ref: '#/components/schemas/ChatCompletionSystemMessageParam'
                  - $ref: '#/components/schemas/ChatCompletionUserMessageParam'
                  - $ref: '#/components/schemas/ChatCompletionAssistantMessageParam'
                  - $ref: '#/components/schemas/ChatCompletionToolMessageParam'
              type: array
            - type: 'null'
          title: History
          description: Chat history
        retrieved_memory_ids:
          anyOf:
            - items:
                type: string
              type: array
            - type: 'null'
          title: Retrieved Memory Ids
          description: Retrieved memory ids at last turn
        feedback_content:
          anyOf:
            - type: string
            - type: 'null'
          title: Feedback Content
          description: Feedback content to process
        feedback_time:
          anyOf:
            - type: string
            - type: 'null'
          title: Feedback Time
          description: Feedback time
        writable_cube_ids:
          anyOf:
            - items:
                type: string
              type: array
            - type: 'null'
          title: Writable Cube Ids
          description: List of cube IDs user can write for multi-cube add
        async_mode:
          type: string
          enum:
            - sync
            - async
          title: Async Mode
          description: 'feedback mode: sync or async'
          default: async
        corrected_answer:
          type: boolean
          title: Corrected Answer
          description: Whether need return corrected answer
          default: false
        info:
          anyOf:
            - additionalProperties: true
              type: object
            - type: 'null'
          title: Info
          description: >-
            Additional metadata for the add request. All keys can be used as
            filters in search. Example: {'agent_id': 'xxxxxx', 'app_id': 'xxxx',
            'source_type': 'web', 'source_url': 'https://www.baidu.com',
            'source_content': 'West Lake is the most famous scenic spot in
            Hangzhou'}.
        mem_cube_id:
          anyOf:
            - type: string
            - type: 'null'
          title: Mem Cube Id
          description: >-
            (Deprecated) Single cube ID to search in. Prefer `readable_cube_ids`
            for multi-cube search.
      type: object
      required:
        - user_id
        - history
        - feedback_content
      title: APIFeedbackRequest
      description: Request model for processing feedback info.
    MemoryResponse:
      properties:
        code:
          type: integer
          title: Code
          description: Response status code
          default: 200
        message:
          type: string
          title: Message
          description: Response message
        data:
          anyOf:
            - items: {}
              type: array
            - type: 'null'
          title: Data
          description: Response data
      type: object
      required:
        - message
      title: MemoryResponse
      description: Response model for memory operations.
    HTTPValidationError:
      properties:
        detail:
          items:
            $ref: '#/components/schemas/ValidationError'
          type: array
          title: Detail
      type: object
      title: HTTPValidationError
    ChatCompletionSystemMessageParam:
      properties:
        content:
          anyOf:
            - type: string
            - items:
                $ref: '#/components/schemas/ChatCompletionContentPartTextParam'
              type: array
            - $ref: '#/components/schemas/ChatCompletionContentPartTextParam'
          title: Content
        role:
          type: string
          const: system
          title: Role
        name:
          type: string
          title: Name
        chat_time:
          anyOf:
            - type: string
            - type: 'null'
          title: Chat Time
        message_id:
          anyOf:
            - type: string
            - type: 'null'
          title: Message Id
      type: object
      required:
        - content
        - role
      title: ChatCompletionSystemMessageParam
    ChatCompletionUserMessageParam:
      properties:
        content:
          anyOf:
            - type: string
            - items:
                anyOf:
                  - $ref: '#/components/schemas/ChatCompletionContentPartTextParam'
                  - $ref: '#/components/schemas/ChatCompletionContentPartImageParam'
                  - $ref: >-
                      #/components/schemas/ChatCompletionContentPartInputAudioParam
                  - $ref: '#/components/schemas/File'
              type: array
            - $ref: '#/components/schemas/ChatCompletionContentPartTextParam'
            - $ref: '#/components/schemas/ChatCompletionContentPartImageParam'
            - $ref: '#/components/schemas/ChatCompletionContentPartInputAudioParam'
            - $ref: '#/components/schemas/File'
          title: Content
        role:
          type: string
          const: user
          title: Role
        name:
          type: string
          title: Name
        chat_time:
          anyOf:
            - type: string
            - type: 'null'
          title: Chat Time
        message_id:
          anyOf:
            - type: string
            - type: 'null'
          title: Message Id
      type: object
      required:
        - content
        - role
      title: ChatCompletionUserMessageParam
    ChatCompletionAssistantMessageParam:
      properties:
        role:
          type: string
          const: assistant
          title: Role
        audio:
          anyOf:
            - $ref: '#/components/schemas/Audio'
            - type: 'null'
        content:
          anyOf:
            - type: string
            - items:
                anyOf:
                  - $ref: '#/components/schemas/ChatCompletionContentPartTextParam'
                  - $ref: '#/components/schemas/ChatCompletionContentPartRefusalParam'
              type: array
            - $ref: '#/components/schemas/ChatCompletionContentPartTextParam'
            - $ref: '#/components/schemas/ChatCompletionContentPartRefusalParam'
            - type: 'null'
          title: Content
        refusal:
          anyOf:
            - type: string
            - type: 'null'
          title: Refusal
        tool_calls:
          anyOf:
            - items:
                anyOf:
                  - $ref: >-
                      #/components/schemas/ChatCompletionMessageFunctionToolCallParam
                  - $ref: >-
                      #/components/schemas/ChatCompletionMessageCustomToolCallParam
              type: array
            - $ref: '#/components/schemas/ChatCompletionMessageFunctionToolCallParam'
            - $ref: '#/components/schemas/ChatCompletionMessageCustomToolCallParam'
          title: Tool Calls
        chat_time:
          anyOf:
            - type: string
            - type: 'null'
          title: Chat Time
        message_id:
          anyOf:
            - type: string
            - type: 'null'
          title: Message Id
      type: object
      required:
        - role
      title: ChatCompletionAssistantMessageParam
    ChatCompletionToolMessageParam:
      properties:
        content:
          anyOf:
            - type: string
            - items:
                anyOf:
                  - $ref: '#/components/schemas/ChatCompletionContentPartTextParam'
                  - $ref: '#/components/schemas/ChatCompletionContentPartImageParam'
                  - $ref: >-
                      #/components/schemas/ChatCompletionContentPartInputAudioParam
                  - $ref: '#/components/schemas/File'
              type: array
            - $ref: '#/components/schemas/ChatCompletionContentPartTextParam'
            - $ref: '#/components/schemas/ChatCompletionContentPartImageParam'
            - $ref: '#/components/schemas/ChatCompletionContentPartInputAudioParam'
            - $ref: '#/components/schemas/File'
          title: Content
        role:
          type: string
          const: tool
          title: Role
        tool_call_id:
          type: string
          title: Tool Call Id
        chat_time:
          anyOf:
            - type: string
            - type: 'null'
          title: Chat Time
        message_id:
          anyOf:
            - type: string
            - type: 'null'
          title: Message Id
      type: object
      required:
        - content
        - role
        - tool_call_id
      title: ChatCompletionToolMessageParam
    ValidationError:
      properties:
        loc:
          items:
            anyOf:
              - type: string
              - type: integer
          type: array
          title: Location
        msg:
          type: string
          title: Message
        type:
          type: string
          title: Error Type
      type: object
      required:
        - loc
        - msg
        - type
      title: ValidationError
    ChatCompletionContentPartTextParam:
      properties:
        text:
          type: string
          title: Text
        type:
          type: string
          const: text
          title: Type
      type: object
      required:
        - text
        - type
      title: ChatCompletionContentPartTextParam
    ChatCompletionContentPartImageParam:
      properties:
        image_url:
          $ref: '#/components/schemas/ImageURL'
        type:
          type: string
          const: image_url
          title: Type
      type: object
      required:
        - image_url
        - type
      title: ChatCompletionContentPartImageParam
    ChatCompletionContentPartInputAudioParam:
      properties:
        input_audio:
          $ref: '#/components/schemas/InputAudio'
        type:
          type: string
          const: input_audio
          title: Type
      type: object
      required:
        - input_audio
        - type
      title: ChatCompletionContentPartInputAudioParam
    File:
      properties:
        file:
          $ref: '#/components/schemas/FileFile'
        type:
          type: string
          const: file
          title: Type
      type: object
      required:
        - file
        - type
      title: File
    Audio:
      properties:
        id:
          type: string
          title: Id
      type: object
      required:
        - id
      title: Audio
    ChatCompletionContentPartRefusalParam:
      properties:
        refusal:
          type: string
          title: Refusal
        type:
          type: string
          const: refusal
          title: Type
      type: object
      required:
        - refusal
        - type
      title: ChatCompletionContentPartRefusalParam
    ChatCompletionMessageFunctionToolCallParam:
      properties:
        id:
          type: string
          title: Id
        function:
          $ref: '#/components/schemas/Function'
        type:
          type: string
          const: function
          title: Type
      type: object
      required:
        - id
        - function
        - type
      title: ChatCompletionMessageFunctionToolCallParam
    ChatCompletionMessageCustomToolCallParam:
      properties:
        id:
          type: string
          title: Id
        custom:
          $ref: '#/components/schemas/Custom'
        type:
          type: string
          const: custom
          title: Type
      type: object
      required:
        - id
        - custom
        - type
      title: ChatCompletionMessageCustomToolCallParam
    ImageURL:
      properties:
        url:
          type: string
          title: Url
        detail:
          type: string
          enum:
            - auto
            - low
            - high
          title: Detail
      type: object
      required:
        - url
      title: ImageURL
    InputAudio:
      properties:
        data:
          type: string
          title: Data
        format:
          type: string
          enum:
            - wav
            - mp3
          title: Format
      type: object
      required:
        - data
        - format
      title: InputAudio
    FileFile:
      properties:
        file_data:
          type: string
          title: File Data
        file_id:
          type: string
          title: File Id
        filename:
          type: string
          title: Filename
      type: object
      title: FileFile
    Function:
      properties:
        arguments:
          type: string
          title: Arguments
        name:
          type: string
          title: Name
      type: object
      required:
        - arguments
        - name
      title: Function
    Custom:
      properties:
        input:
          type: string
          title: Input
        name:
          type: string
          title: Name
      type: object
      required:
        - input
        - name
      title: Custom

````